function trim(s,  t)
{
	t = s
	sub(/^[ \t]+/,"",t)
	sub(/[ \t]+$/,"",t)
	return t
}

function asm_text(s) {
	print s > Output_file
}
function bas_text(s) {
	print s > BAS_Output_file
}


BEGIN {
	Output_file = "bascompi.asm"
	BAS_Output_file = "bascompi_orz.bas"

	bas_text("do")
	bas_text("    wait 1")
	bas_text("    restore aaa")
	bas_text("    gosub bbb")
	bas_text("loop")
	bas_text("end")
	bas_text("")
	bas_text("bbb:")
	bas_text("do")
	bas_text("    read a")
	bas_text("    if a=0 then")
	bas_text("        exit do")
	bas_text("    end if")
	bas_text("    wt1=a")
	bas_text("    read a")
	bas_text("    if a=0 then")
	bas_text("        waitms wt1")
	bas_text("    else")
}
/(Sound|sound)/ {
	port_s = substr($2,1,7)
	port_s = toupper(substr(port_s,1,1))tolower(substr(port_s,2))
	sound_s = "Sound "port_s",wt1,a"
	bas_text("        "sound_s)
	exit_code = 21
}
/^(Data|data) / {
	i = index($0,"Data")
	s = substr($0,i+5)
#	print s
	n = split(s,dd,",")
	for (i = 1; i <= n; i++) {
		ddi = trim(dd[i])
		if (ddi) {
			orgel_data[j++] = ddi
		}
	}


}
END {
	CPU_Clock = 1000000

	data_oct[0] = 640
	data_oct[1] = 320
	data_oct[2] = 160
	data_oct[3] = 80
	data_oct[4] = 40
	data_oct[5] = 20
	data_oct[6] = 10

	data_freq[1] = 33228
	data_freq[2] = 35200
	data_freq[3] = 37296
	data_freq[4] = 39511
	data_freq[5] = 0
	data_freq[6] = 20930
	data_freq[7] = 22175
	data_freq[8] = 23493
	data_freq[9] = 24890
	data_freq[10] = 26370
	data_freq[11] = 0
	data_freq[12] = 27938
	data_freq[13] = 29600
	data_freq[14] = 31360
	data_freq[15] = 33224

	n = split("64 48 32 24 16 12 08 06 04 03 02 01",oncho)
	for (i = 1; i <= n; i++) {
		oncho_s[oncho[i]] = 64/(oncho[i]+0)""
	}
	n = split(" V h  ~ t@ \",onmei)
	onmei[0] = "x"

#	asm_text(".include \"tn2313def.inc\"")
#	asm_text("")

	bas_text("    end if")
	bas_text("loop")
	bas_text("return")
	bas_text("")
	bas_text("aaa:")

	tempo = orgel_data[0]
	for (i = 1; i < j - 1; i++) {
		ddi = substr(orgel_data[i],2,5)
		onmei_e = substr(ddi,2,1)
		oncho_e = substr(ddi,4)
		if (substr(oncho_e,1,1) == "0") {
			oncho_e = substr(oncho_e,2)
		}
		ddi1 = substr(ddi,1,1)
		ddi2 = substr(ddi,1,2)
		sub(/_/," ",ddi2)
		ddi3 = substr(ddi,3,1)
		sub(/_/,"",ddi3)
		ddi4 = substr(ddi,4)
		oct = 4
		if (ddi1 == "+") {
			oct = 5
		} else if (ddi1 == "-") {
			oct = 3
		}
		mtempo = int(4800/tempo)
		octa = data_oct[oct]
		onkai = index("ABCDEFG",onmei_e)*2 + (ddi1=="#"?1:0 + ddi1=="b"?-1:0)

		freq = data_freq[onkai]
		wt1 = int(mtempo*ddi4*int(freq/octa)/1000)
		aa = int(freq/octa)
		if (aa == 0) {
			wt1 = mtempo*ddi4
			wt2 = 0
		} else {
			wt2 = int(CPU_Clock/(int(freq/octa)*12))
		}
#		print  ddi ": "ddi2 ddi3 " ("onmei[index("ABCDEFG",onmei_e)]")" (ddi4=="64"?"S":oncho_s[ddi4])  ","freq ","wt1","wt2
#		asm_text(".dw "wt1","wt2)
		bas_text("Data "wt1"%,"wt2"%")
	}
	bas_text("Data 0%,0%")
	exit exit_code
}
